menu = {}
menu.current = 1
menu.cfg = {}
menu.cfg.version = 2
if love.filesystem.exists "settings.cfg" then
	cfg = love.filesystem.load "settings.cfg" ()
	if cfg.version ~= menu.cfg.version then
		cfg = {20, 0, 192, 0, 0, 0, 192, false, true, 160, ''}
	end
else
	cfg = {20, 0, 192, 0, 0, 0, 192, false, true, 160, ''}
end

love.keyboard.setKeyRepeat(.25, .0075)	
	menu.main = {text = {}, gui = love.filesystem.load 'gui.lua' ()}
		menu.main[1] = menu.main.gui:newButton(0, 0, function() state = game; if not pause then game.load() end; pause = false end, 'Play')
		menu.main[2] = menu.main.gui:newButton(0, 0, function() menu.state = menu.options end, 'Options')
		menu.main[3] = menu.main.gui:newButton(0, 0, function() if not pause then love.event.quit(); else state = menu; pause = false; end end, 'Quit')
		
	menu.options = {text = {}, gui = love.filesystem.load 'gui.lua' ()}
		menu.options.text[1] = 'Speed'
		menu.options.text[2] = 'Snake1 - R'
		menu.options.text[3] = 'Snake1 - G'
		menu.options.text[4] = 'Snake1 - B'
		menu.options.text[5] = 'Snake2 - R'
		menu.options.text[6] = 'Snake2 - G'
		menu.options.text[7] = 'Snake2 - B'
		menu.options.text[8] = 'Face'
		menu.options.text[9] = 'Transparent tail'
		menu.options.text[10] = 'Tail transparency'
		menu.options.text[11] = 'Back'
		menu.options[1] = menu.options.gui:newSlider(0, 0, 7, 120, cfg[1], nil, nil, nil, nil, 1)
		menu.options[2] = menu.options.gui:newSlider(0, 0, 0, 255, cfg[2], nil, nil, nil, nil, 2)
		menu.options[3] = menu.options.gui:newSlider(0, 0, 0, 255, cfg[3], nil, nil, nil, nil, 3)
		menu.options[4] = menu.options.gui:newSlider(0, 0, 0, 255, cfg[4], nil, nil, nil, nil, 4)
		menu.options[5] = menu.options.gui:newSlider(0, 0, 0, 255, cfg[5], nil, nil, nil, nil, 5)
		menu.options[6] = menu.options.gui:newSlider(0, 0, 0, 255, cfg[6], nil, nil, nil, nil, 6)
		menu.options[7] = menu.options.gui:newSlider(0, 0, 0, 255, cfg[7], nil, nil, nil, nil, 7)
		menu.options[8] = menu.options.gui:newCheckbox(0, 0, cfg[8], '', nil, nil, nil, nil, nil, 8)
		menu.options[9] = menu.options.gui:newCheckbox(0, 0, cfg[9], '', nil, nil, nil, nil, nil, 9)
		menu.options[10] = menu.options.gui:newSlider(0, 0, 0, 255, cfg[10], nil, nil, nil, nil, 10)
		menu.options[11] = menu.options.gui:newButton(0, 0, function() menu.state = menu.main end, menu.options.text[11])

menu.state = menu.main
	
menu.load = function()
	
end

menu.update = function(dt)
	menu.state.gui:update(dt)
end

menu.draw = function()
	if pause then
		love.graphics.draw(canvas, 0, 0)
		snake1:draw()
		snake2:draw()
		love.graphics.print('FPS: ' .. love.timer.getFPS() .. ' | ' .. 1/love.timer.getDelta(), map.width*17, 1)
		love.graphics.draw(grey, 0, 0)
	end
	for i, v in ipairs(menu.state) do
		love.graphics.setColor(255,255,255)
		love.graphics.print(menu.state.text[i] or '', 320, ((800/48)-#menu.state)+i*48 - 16)
		v:draw(320, ((800/48)-#menu.state)+i*48)
		love.graphics.printf(tonumber(menu.state[i].value) or '', 0, ((800/48)-#menu.state)+i*48 + 16, 800, 'center')
	end
end

menu.keypressed = function(key, unicode)
	menu.state.gui:keypressed(key, unicode)
end

menu.mousepressed = function(x, y, b)
	menu.state.gui:mousepressed(x, y, b)
end

menu.quit = function()
	love.filesystem.remove('settings.cfg')
	local cfgFile = love.filesystem.newFile('settings.cfg')
	cfgFile:open('w')
	cfgFile:write "local cfg = { \n"
	for i, v in ipairs(cfg) do
		if v ~= '' then
			cfgFile:write('	' .. tostring(v) .. ', \n')
		end
	end
	cfgFile:write ("version = " .. menu.cfg.version .. "\n")
	cfgFile:write "}\n"
	cfgFile:write "return cfg"
	cfgFile:close()
end